#! /bin/sh
# Script to install semigroupe
# You need to be root

# Usage : sudo ./install_semigroupe [name_dir1 name_dir2]
#
# The parameters name_dir1 name_dir2 are optional. If you just type
#
# sudo ./install_semigroupe
#
# semigroupe will be intalled in /usr/local/bin and the
# directory BABEL will be created in /usr/local/etc
# If you want to install semigroupe in /usr/bin, 
# and install BABEL in /BABELpath/BABELfolder just type
#
# sudo ./install_semigroupe "/usr/bin" "/BABELpath/BABELfolder"
#
# tar -zxvf semigroupe.tar.gz


if [ $# -gt 0 ]
then  
  INSTALL_DIR="$1"
else
  INSTALL_DIR="/usr/local/bin"
fi

if [ $# -gt 0 ]
then  
  INSTALL_BABEL="$2"
else
  INSTALL_BABEL="/usr/local/etc"
fi

cd Sources
# If no argument, default installation
if [ $# -gt 0 ]
then  
  sed s!/usr/local/bin!$INSTALL_DIR! Preferences.h > Preferences.temp;
  mv Preferences.temp Preferences.h;
fi

echo Compiling...
make semigroupe
mv semigroupe.out ..
make clean

cd ..
if (test -e "semigroupe") then
	echo removing old file "semigroupe"
	rm semigroupe
fi

# Creating the command semigroupe
echo "#! /bin/sh" > semigroupe
echo semigroupe.out \$HOME "$INSTALL_BABEL" >> semigroupe
chmod +x semigroupe

# Creating directories if needed
if (test -d $INSTALL_BABEL) then
	echo "Directory $INSTALL_BABEL found"
else
	echo "No directory $INSTALL_BABEL ! Creating a new one";
	mkdir $INSTALL_BABEL;
fi

if (test -d $INSTALL_DIR) then
	echo "Directory $INSTALL_DIR found"
else
	echo "No directory $INSTALL_DIR ! Creating a new one";
	mkdir $INSTALL_DIR;
fi

mv semigroupe $INSTALL_DIR
mv semigroupe.out $INSTALL_DIR
cp -R Babel $INSTALL_BABEL

